//BlocsDeverrouiller_502f.js
// 22.05.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Dverrouiller des blocs

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// appeler la fonction qui lit les rglages enregistrs
var allPrefs  = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var cVal1   = prefVal[0];
	var cVal2   = prefVal[1];
	var cVal3   = prefVal[2];
	var cVal4   = prefVal[3];
	var cVal5   = prefVal[4];
	var rVal1   = prefVal[5];
	var cVal6   = prefVal[6];
	var rVal2   = prefVal[7];
	var pNum    = prefVal[8];
	ck01 = ck02 = ck03 = ck04 = ck05 = ck06 = 1;
	if (cVal1  == "false") { ck01 = 0; }
	if (cVal2  == "false") { ck02 = 0; }
	if (cVal3  == "false") { ck03 = 0; }
	if (cVal4  == "false") { ck04 = 0; }
	if (cVal5  == "false") { ck05 = 0; }
	rb01 = rb05 = 1;
	rb02 = rb03 = rb04 = rb06 = 0;
	if (rVal1  == "1") {
		rb01 = 0;
		rb02 = 1;
	}
	else if (rVal1 == "2") {
		rb01 = 0;
		rb03 = 1;
	}
	else if (rVal1 == "3") {
		rb01 = 0;
		rb04 = 1;
	}
	if (cVal6  == "false") { ck06 = 0; }
	if (rVal2  == "1") {
		rb05 = 0;
		rb06 = 1;
	}
}
else {
	// lorsque le fichier des prfrences ne peut pas tre trouv, 
	// utiliser les valeurs par dfaut suivants
	ck01 =  1;
	ck02 =  1;
	ck03 =  1;
	ck04 =  1;
	ck05 =  1;
	rb01 =  0;
	rb02 =  1;
	rb03 =  0;
	rb04 =  0;
	ck06 =  1;
	rb05 =  1;
	rb06 =  0;
	pNum = "";
}

// appeler la fonction qui affiche le dialogue pour prendre une dcision
var userDec = askUser1();

// mettre le rsultat dans des variables
textFrm = userDec[0];
pictFrm = userDec[1];
noneFrm = userDec[2];
lineFrm = userDec[3];
grpeFrm = userDec[4];
docuRge = userDec[5];
actLayr = userDec[6];
anchObj = userDec[7];

// vrifier les genres des blocs
var frameTypes = 0;
if (textFrm == true) {
	frameTypes += 1;
}
if (pictFrm == true) {
	frameTypes += 2;
}
if (noneFrm == true) {
	frameTypes += 4;
}
if (lineFrm == true) {
	frameTypes += 8;
}
if (grpeFrm == true) {
	frameTypes += 16;
}
if (frameTypes == 0) {
	alert ("Il faut slectionner au moins un genre de bloc.", "Stop", true);
	exit();
}

// mmoriser le calque actif
if (actLayr) {
	curLayer = app.activeWindow.activeLayer;
}

// dclencher l'action selon la dcision
if (docuRge == 0) { // "les blocs slectionns"
	var tgtFrames = app.selection;
	var nFrames   = tgtFrames.length;
	if (nFrames == 0) {
		alert ("Il n'y a pas de slection.", "Stop");
		exit();
	}
	prepLock(tgtFrames, nFrames);
}
else if (docuRge == 1) { // "sur la planche active"
	var tgtFrames = app.activeWindow.activeSpread.pageItems.everyItem().getElements();
	var nFrames   = tgtFrames.length;
	prepLock(tgtFrames, nFrames);
}
else if (docuRge == 2) { // "dans une range de pages  dfinir"
	var curDoc = app.documents[0];
	// tester, s'il y a des prfixes
	sectPrefs = false;
	var allPrefNames = new Array();
	for (var p=0; p<curDoc.pages.length; p++) {
		var curSect = curDoc.pages[p].appliedSection.name;
		allPrefNames.push(curSect);
	}
	var testString = allPrefNames.join("");
	if (testString.length > 0) {
		sectPrefs = true;
	}
	// la liste des numros des pages
	if (sectPrefs == false) {
		allPageNames = curDoc.pages.everyItem().name;
	}
	else {
		var allPageNames = new Array();
		for (var p=0; p<curDoc.pages.length; p++) {
			var curName = curDoc.pages[p].name;
			allPageNames.push(allPrefNames[p] + curName);
		}
	}
	// appeler le dialogue pour la saisie des numros
	var pageRange = askUser2();
	// envoyer la saisie au test
	if (sectPrefs == false) {
		allPages = rangeNoSectPref(pageRange);
	}
	else {
		allPages = rangeWithSectPref(pageRange);
	}
	// une boucle  travers les pages
	for (var p=0; p<allPages.length; p++) {
		var tgtFrames = app.documents[0].pages[allPages[p]].pageItems.everyItem().getElements();
		var nFrames   = tgtFrames.length;
		prepLock(tgtFrames, nFrames)
	}
}
else if (docuRge == 3) { // "dans le document entier"
	var tgtFrames = app.documents[0].pageItems.everyItem().getElements();
	var nFrames   = tgtFrames.length;
	prepLock(tgtFrames, nFrames);
}

// la liste des rglages...
var prefsList = new Array(textFrm, pictFrm, noneFrm, lineFrm, grpeFrm, docuRge, actLayr, anchObj, pageRange);
// ... la convertir en chane de texte...
var prefString = prefsList.join("\n");
// ... et l'envoyer  la fonction, qui l'crit dans un fichier
writeResult(prefString);

// annoncer la fin de l'action
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Termin.");
dlog.show();
// une petite pause
$.sleep(999);
// fermer la fentre
dlog.close();


////////////////////////////// les fonctions  /////////////////////////////////////////////////////

// la fonction qui prpare les informations ///////////////////////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// lire le fichier contenant les valeurs enregistres
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/BlocsDeverrouiller_502.txt");
	}
	else {
		var f = new File("~/Library/Preferences/BlocsDeverrouiller_502.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// prparer et afficher le premier dialogue ///////////////////////////////////////////////////////
function askUser1() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth0 =  16;
	var labelWidth1 =   4;
	var labelWidth2 =  88;
	var labelWidth3 = 129;
	var aDialog = app.dialogs.add({name:"BlocsDeverrouiller"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"O est-ce qu'il faut dverrouiller les blocs?"});
				staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				var checkbox01 = checkboxControls.add({staticLabel:"blocs texte", checkedState:ck01, minWidth:labelWidth2});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				var checkbox02 = checkboxControls.add({staticLabel:"blocs image", checkedState:ck02, minWidth:labelWidth2});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				var checkbox03 = checkboxControls.add({staticLabel:"contenu non attribu", checkedState:ck03, minWidth:labelWidth2});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				var checkbox04 = checkboxControls.add({staticLabel:"blocs trait", checkedState:ck04, minWidth:labelWidth2});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				var checkbox05 = checkboxControls.add({staticLabel:"groupes", checkedState:ck05, minWidth:labelWidth2});
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							with(refButtons1 = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"les blocs slectionns", checkedState:rb01});
								radiobuttonControls.add({staticLabel:"sur la planche active", checkedState:rb02});
								radiobuttonControls.add({staticLabel:"dans une range de pages  dfinir", checkedState:rb03});
								radiobuttonControls.add({staticLabel:"dans le document entier", checkedState:rb04});
							}
						}
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				var checkbox06 = checkboxControls.add({staticLabel:"que sur le calque actif", checkedState:ck06, minWidth:labelWidth2});
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"les blocs ancrs..."});
							staticTexts.add({staticLabel:" ", minWidth:labelWidth3});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							with(refButtons2 = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"les laisser verrouills", checkedState:rb05});
								radiobuttonControls.add({staticLabel:"les dverrouiller", checkedState:rb06});
							}
						}
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		ck01 = checkbox01.checkedState;
		ck02 = checkbox02.checkedState;
		ck03 = checkbox03.checkedState;
		ck04 = checkbox04.checkedState;
		ck05 = checkbox05.checkedState;
		var refDec1 = refButtons1.selectedButton;
		ck06 = checkbox06.checkedState;
		var refDec2 = refButtons2.selectedButton;
		// supprimer le dialogue
		aDialog.destroy();
		// renvoyer les valeurs
		return [ck01, ck02, ck03, ck04, ck05, refDec1, ck06, refDec2];
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// prparer et afficher le second dialogue ////////////////////////////////////////////////////////
function askUser2() {
	var fieldWidth  = 350;
	var aDialog = app.dialogs.add({name:"BlocsDeverrouiller"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Entrer la range (par ex. 1, 2-3, 4-7, 8):"});
				staticTexts.add({staticLabel:" ", minWidth:10});
			}
			with (dialogRows.add()) {
				var pagesField = textEditboxes.add({editContents:pNum, minWidth:fieldWidth});
			}
		}
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:4});
			}
		}
	}
	if(aDialog.show() == true) {
		pNum = pagesField.editContents;
		// supprimer le dialogue
		aDialog.destroy();
		// ... tester la saisie...
		if (pNum == "") {
			alert ("Range de pages:\n\nle champ texte est vide.", "Stop");
			exit();
		}
		// ... et renvoyer le rsultat
		return pNum;
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// lister les numros des pages, tester s'ils existent ////////////////////////////////////////////
function rangeNoSectPref(pageRange) {  // quand il n'y a pas de prfixes //////////////////////////
	var whatKind = 0;
	var pagesList = new Array();
	var indList   = new Array();
	// supprimer des espaces
	var newRange = pageRange.split(" ");
	newRange = newRange.join("");
	// vrifier si l'entre contient des virgules et/ou des traits d'union et/ou des signes plus
	if (newRange.indexOf("-") != -1) {
		whatKind = whatKind + 1;
	}
	if (newRange.indexOf(",") != -1) {
		whatKind = whatKind + 2;
	}
	if (newRange.indexOf("+") != -1) {
		whatKind = whatKind + 4;
	}
	// prparer les listes selon le genre de la chane
	if (whatKind == 0) {
		pagesList.push(newRange);
	}
	else if (whatKind == 1) {
		var newRangeList = newRange.split("-");
		var startVal = newRangeList[0]*1;
		var stopVal  = (newRangeList[1]*1);
		if (startVal<stopVal) {
			for (var i=startVal; i<stopVal+1; i++) {
				pagesList.push(""+i);
			}
		}
		else {
			for (var i=stopVal; i<startVal+1; i++) {
				pagesList.push(""+i);
			}
		}
	}
	else if (whatKind == 2) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			pagesList.push(newRangeList[i]);
		}
	}
	else if (whatKind == 3) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var tmpItemList = tmpItem.split("-");
				var startVal = tmpItemList[0]*1;
				var stopVal  = (tmpItemList[1]*1);
				if (startVal<stopVal) {
					for (var k=startVal; k<stopVal+1; k++) {
						pagesList.push(""+k);
					}
				}
				else {
					for (var k=stopVal; k<startVal+1; k++) {
						pagesList.push(""+k);
					}
				}
			}
			else {
				pagesList.push(newRangeList[i]);
			}
		}
	}
	else if (whatKind == 4) {
		indList.push((newRange*1)-1);
	}
	else if (whatKind == 5) {
		var newRangeList = newRange.split("-");
		var startVal = (newRangeList[0]*1);
		var stopVal  = (newRangeList[1]*1);
		if (startVal<stopVal) {
			for (var i=startVal-1; i<stopVal; i++) {
				indList.push(i);
			}
		}
		else {
			for (var i=stopVal-1; i<startVal; i++) {
				indList.push(i);
			}
		}
	}
	else if (whatKind == 6) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			if (newRangeList[i][0] == "+") {
				indList.push((newRangeList[i]*1)-1);
			}
			else {
				var okay = false;
				for (var k=0; k<allPageNames.length; k++) {
					if (newRangeList[i] == allPageNames[k]) {
						indList.push(k);
						okay = true;
						break;
					}
				}
				if (!okay) {
					alert ("La page " + newRangeList[i] + " est introuvable.", "Stop");
					exit();
				}
			}
		}
	}
	else if (whatKind == 7) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var tmpItemList = tmpItem.split("-");
				var startVal = (tmpItemList[0]*1);
				var stopVal  = (tmpItemList[1]*1);
				if (startVal<stopVal) {
					for (var k=startVal-1; k<stopVal; k++) {
						indList.push(k);
					}
				}
				else {
					for (var k=stopVal-1; k<startVal; k++) {
						indList.push(k);
					}
				}
			}
			else {
				if (newRangeList[i][0] == "+") {
					indList.push((newRangeList[i]*1)-1);
				}
				else {
					var okay = false;
					for (var k=0; k<allPageNames.length; k++) {
						if (newRangeList[i] == allPageNames[k]) {
							indList.push(k);
							okay = true;
							break;
						}
					}
					if (!okay) {
						alert ("La page " + newRangeList[i] + " est introuvable.", "Stop");
						exit();
					}
				}
			}
		}
	}
	// vrifier si les pages dsires existent
	if (whatKind < 4) {
		var nNum = pagesList.length;
		for (var i=0; i<nNum; i++) {
			var okay = false;
			var actNum = pagesList[i];
			for (var k=0; k<allPageNames.length; k++) {
				if (actNum == allPageNames[k]) {
					okay = true;
					indList.push(k);
					break;
				}
			}
		}
		if (okay) {
			return indList;
		}
		else {
			alert ("La page " + actNum + " est introuvable.", "Stop");
			exit();
		}
	}
	else {
		var maxInd = (allPageNames.length)-1;
		for (var i=0; i<indList.length; i++) {
			if (indList[i] > maxInd) {
				alert ("La page +" + (indList[i]+1) + " est introuvable.", "Stop");
				exit();
			}
		}
	}
	return indList;
}

function rangeWithSectPref(pageRange) {  // quand il y a des prfixes /////////////////////////////
	var whatKind = 0;
	var indList  = new Array();
	// supprimer des espaces
	var newRange = pageRange.split(" ");
	newRange = newRange.join("");
	// vrifier si l'entre contient des virgules et/ou des traits d'union et/ou des signes plus
	if (newRange.indexOf("-") != -1) {
		whatKind = whatKind + 1;
	}
	if (newRange.indexOf(",") != -1) {
		whatKind = whatKind + 2;
	}
	if (newRange.indexOf("+") != -1) {
		whatKind = whatKind + 4;
	}
	// prparer les listes selon le genre de la chane
	if (whatKind == 0) {
		var startVal  = -1;
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == newRange) {
				startVal = n;
				break;
			}
		}
		if (startVal != -1) {
			indList.push(n);
		}
		else {
			alert ("La page " + newRange + " est introuvable.", "Stop");
			exit();
		}
	}
	else if (whatKind == 1) {
		var startVal = -1;
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == newRange) {
				startVal = n;
				break;
			}
		}
		if (startVal != -1) {
			indList.push(n);
		}
		else {
			var newRangeList = newRange.split("-");
			if (newRangeList.length == 2) {
				var startPage = newRangeList[0];
				var stopPage  = newRangeList[1];
			}
			else if (newRangeList.length == 3) {
				var startVal  = -1;
				var startPage = newRangeList[0];
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == startPage) {
						startVal = n;
						break;
					}
				}
				if (startVal != -1) {
					var stopPage  = newRangeList[1]+"-"+newRangeList[2];
				}
				else {
					var startPage = newRangeList[0]+"-"+newRangeList[1];
					var stopPage  = newRangeList[2];
				}
			}
			else if (newRangeList.length == 4) {
				var startPage = newRangeList[0]+"-"+newRangeList[1];
				var stopPage  = newRangeList[2]+"-"+newRangeList[3];
			}
			var startVal  = -1;
			var stopVal   = -1;
			for (var n=0; n<allPageNames.length; n++) {
				if (allPageNames[n] == startPage) {
					startVal = n;
					break;
				}
			}
			for (var n=0; n<allPageNames.length; n++) {
				if (allPageNames[n] == stopPage) {
					stopVal = n;
					break;
				}
			}
			if (startVal == -1) {
				alert ("La page " + startPage + " est introuvable.", "Stop");
				exit();
			}
			if (stopVal == -1) {
				alert ("La page " + stopPage + " est introuvable.", "Stop");
				exit();
			}
			if (startVal<stopVal) {
				for (var i=startVal; i<stopVal+1; i++) {
					indList.push(i);
				}
			}
			else {
				for (var i=stopVal; i<startVal+1; i++) {
					indList.push(i);
				}
			}
		}
	}
	else if (whatKind == 2) {
		var newRangeList = newRange.split(",");
		var startPage = newRangeList[0];
		var stopPage  = newRangeList[1];
		var startVal  = -1;
		var stopVal   = -1;
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == startPage) {
				startVal = n;
				indList.push(n);
				break;
			}
		}
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == stopPage) {
				stopVal = n;
				indList.push(n);
				break;
			}
		}
		if (startVal == -1) {
			alert ("La page " + startPage + " est introuvable.", "Stop");
			exit();
		}
		if (stopVal == -1) {
			alert ("La page " + stopPage + " est introuvable.", "Stop");
			exit();
		}
	}
	else if (whatKind == 3) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var startVal = -1;
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == tmpItem) {
						startVal = n;
						break;
					}
				}
				if (startVal != -1) {
					startPage = tmpItem;
					stopPage  = tmpItem;
				}
				else {
					var tmpList = tmpItem.split("-");
					if (tmpList.length == 2) {
						var startPage = tmpList[0];
						var stopPage  = tmpList[1];
					}
					else if (tmpList.length == 3) {
						var startVal  = -1;
						var startPage = tmpList[0];
						for (var n=0; n<allPageNames.length; n++) {
							if (allPageNames[n] == startPage) {
								startVal = n;
								break;
							}
						}
						if (startVal != -1) {
							var stopPage  = tmpList[1]+"-"+tmpList[2];
						}
						else {
							var startPage = tmpList[0]+"-"+tmpList[1];
							var stopPage  = tmpList[2];
						}
					}
					else if (tmpList.length == 4) {
						var startPage = tmpList[0]+"-"+tmpList[1];
						var stopPage  = tmpList[2]+"-"+tmpList[3];
					}
				}
				var startVal  = -1;
				var stopVal   = -1;
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == startPage) {
						startVal = n;
						break;
					}
				}
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == stopPage) {
						stopVal = n;
						break;
					}
				}
				if (startVal == -1) {
					alert ("La page " + startPage + " est introuvable.", "Stop");
					exit();
				}
				if (stopVal == -1) {
					alert ("La page " + stopPage + " est introuvable.", "Stop");
					exit();
				}
				if (startVal<stopVal) {
					for (var k=startVal; k<stopVal+1; k++) {
						indList.push(k);
					}
				}
				else {
					for (var k=stopVal; k<startVal+1; k++) {
						indList.push(k);
					}
				}
			}
			else {
				var startPage = newRangeList[i];
				var startVal  = -1;
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == startPage) {
						startVal = n;
						break;
					}
				}
				if (startVal != -1) {
					indList.push(n);
				}
				else {
					alert ("La page " + startPage + " est introuvable.", "Stop");
					exit();
				}
			}
		}
	}
	else if (whatKind == 4) {
		indList.push((newRange*1)-1);
	}
	else if (whatKind == 5) {
		var newRangeList = newRange.split("-");
		var startVal = (newRangeList[0]*1);
		var stopVal  = (newRangeList[1]*1);
		if (startVal<stopVal) {
			for (var i=startVal-1; i<stopVal; i++) {
				indList.push(i);
			}
		}
		else {
			for (var i=stopVal-1; i<startVal; i++) {
				indList.push(i);
			}
		}
	}
	else if (whatKind == 6) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			if (newRangeList[i][0] == "+") {
				indList.push((newRangeList[i]*1)-1);
			}
			else {
				var okay = false;
				for (var k=0; k<allPageNames.length; k++) {
					if (newRangeList[i] == allPageNames[k]) {
						indList.push(k);
						okay = true;
						break;
					}
				}
				if (!okay) {
					alert ("La page " + newRangeList[i] + " est introuvable.", "Stop");
					exit();
				}
			}
		}
	}
	else if (whatKind == 7) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var tmpItemList = tmpItem.split("-");
				var startVal = (tmpItemList[0]*1);
				var stopVal  = (tmpItemList[1]*1);
				if (startVal<stopVal) {
					for (var k=startVal-1; k<stopVal; k++) {
						indList.push(k);
					}
				}
				else {
					for (var k=stopVal-1; k<startVal; k++) {
						indList.push(k);
					}
				}
			}
			else {
				if (newRangeList[i][0] == "+") {
					indList.push((newRangeList[i]*1)-1);
				}
				else {
					var okay = false;
					for (var k=0; k<allPageNames.length; k++) {
						if (newRangeList[i] == allPageNames[k]) {
							indList.push(k);
							okay = true;
							break;
						}
					}
					if (!okay) {
						alert ("La page " + newRangeList[i] + " est introuvable.", "Stop");
						exit();
					}
				}
			}
		}
	}
	// vrifier si les pages dsires existent
	if (whatKind > 3) {
		var maxInd = (allPageNames.length)-1;
		for (var i=indList.length-1; i>-1; i--) {
			if (indList[i] > maxInd) {
				alert ("La page +" + (indList[i]+1) + " est introuvable.", "Stop");
				exit();
			}
		}
	}
	return indList;
}

// prparer le verrouillage ///////////////////////////////////////////////////////////////////////
function prepLock(tgtFrames, nFrames) {
	for (var n=0; n<nFrames; n++) {
		var grabAll  = true;
		var curFrame = tgtFrames[n];
		if (actLayr) {
			try {
				if (curFrame.itemLayer != curLayer) {
					continue;
				}
			}
			catch (e) {
				continue;
			}
		}
		var curType  = curFrame.constructor.name;
		if (curType == "Group") {
			grabAll = false;
		}
		if (frameTypes == 31) {
			unLockOne(curFrame);
		}
		else {
			if (curType == "Rectangle" || curType == "Oval") {
				curType = (curFrame.contentType)*1;
			}
			else if (curType == "Polygon") {
				var actPath = (curFrame.paths[0].pathType)*1;
				if (actPath == 1668051812) { // = un trac ferm
					curType = (curFrame.contentType)*1;
				}
				else if (actPath == 1869639280) { // = un trac ouvert
					if (curFrame.textPaths[0].isValid) {
						curType = "TextFrame";
					}
					else {
						curType = "GraphicLine";
					}
				}
			}
			if (checkType(frameTypes, curType)) {
				unLockOne(curFrame);
			}
		}
		if (grabAll) {
			var allFrames = curFrame.allPageItems;
			var nnnFrames = allFrames.length;
			if (nnnFrames > 0) {
				for (var k=0; k<nnnFrames; k++) {
					var curFrame = allFrames[k];
					if (frameTypes == 31) {
						unLockOne(curFrame);
					}
					else {
						var curType = curFrame.constructor.name;
						if (curType == "Rectangle" || curType == "Oval") {
							curType = (curFrame.contentType)*1;
						}
						else if (curType == "Polygon") {
							var actPath = (curFrame.paths[0].pathType)*1;
							if (actPath == 1668051812) { // = un trac ferm
								curType = (curFrame.contentType)*1;
							}
							else if (actPath == 1869639280) { // = un trac ouvert
								if (curFrame.textPaths[0].isValid) {
									curType = "TextFrame";
								}
								else {
									curType = "GraphicLine";
								}
							}
						}
						if (checkType(frameTypes, curType)) {
							unLockOne(curFrame);
						}
					}
				}
			}
		}
	}
}

// tester le genre de bloc ////////////////////////////////////////////////////////////////////////
function checkType(frameTypes, curType) {
	var typeNbr = "|"+frameTypes+"|";
	if (curType == "TextFrame" || curType == 1952412773) { // = bloc texte
		if (("|1|3|5|7|9|11|13|15|17|19|21|23|25|27|29|").indexOf(typeNbr) != -1) {
			return true;
		}
	}
	else if (curType == 1735553140) { // = bloc image
		if (("|2|3|6|7|10|11|14|18|19|22|23|25|27|30|").indexOf(typeNbr) != -1) {
			return true;
		}
	}
	else if (curType == 1970168179) { // = contenun non attribu
		if (("|4|5|6|7|12|13|14|15|20|21|22|23|28|29|30|").indexOf(typeNbr) != -1) {
			return true;
		}
	}
	else if (curType == "GraphicLine") { // = bloc trait
		if (("|8|9|10|11|12|13|14|15|24|25|26|27|28|29|30|").indexOf(typeNbr) != -1) {
			return true;
		}
	}
	else if (curType == "Group") { // = groupe
		if (("|16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|").indexOf(typeNbr) != -1) {
			return true;
		}
	}
	return false;
}

// dverrouiller le bloc courant //////////////////////////////////////////////////////////////////
function unLockOne(oneFrame) {
	if (oneFrame.parent != "[object Character]") {
		// si le bloc est verrouill...
		if (oneFrame.locked == true) {
			// ... le dverrouiller
			try {
				oneFrame.locked = false;
			}
			catch (e) {
			}
		}
	}
	else {
		// s'il faut galement dverrouiller des blocs ancrs
		if (anchObj == 1) {
			// si le bloc est verrouill...
			if (oneFrame.locked == true) {
				// ... le dverrouiller
				try {
					oneFrame.locked = false;
				}
				catch (e) {
				}
			}
			// quand "Empcher le positionnement manuel" est coch...
			if (oneFrame.anchoredObjectSettings.lockPosition == true) {
				// ... dcocher la case
				oneFrame.anchoredObjectSettings.lockPosition = false;
			}
		}
	}
}

// crire le rsultat dans un fichier /////////////////////////////////////////////////////////////
function writeResult(prefString) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/BlocsDeverrouiller_502.txt");
	}
	else {
		var f = new File("~/Library/Preferences/BlocsDeverrouiller_502.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(prefString);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}